Home > Articles > Operating Systems, Server > Linux/UNIX/Open Source

Shell Programming FAQs

This lesson addresses some of the most commonly asked questions about shell programming, commands, input, output, variables, arguments and files.
This chapter is from the book

Each of the previous chapters has focused on an individual topic in shell programming, such as variables, loops, or debugging. As you progressed through the book, you worked on problems that required knowledge from previous chapters. This chapter takes a slightly different approach by trying to answer some frequently asked shell programming questions. Specifically, this chapter covers questions from three main areas of shell programming:

  • The shell and commands

  • Variables and arguments

  • Files and directories

Each section includes several common shell programming questions (and answers!). These questions are designed to help you solve or avoid common problems. Some of the questions provide deeper background information about UNIX, whereas others illustrate concepts covered in previous chapters.

Shell and Command Questions

This section covers some of the common questions about the shell itself and how the shell executes commands.

Why does #!/bin/sh have to be the first line of my scripts?

Chapter 2, "Script Basics," stated that #!/bin/sh must be the first line in your script to ensure that the correct shell is used to execute your script. This line must be the first line in your shell script because of the underlying mechanism used by a shell to execute commands.

When you ask a shell to execute a command as follows

$ date

The shell uses the exec system call to ask the UNIX kernel to execute the command you requested. System calls are C language functions built in to the UNIX kernel that enable you to access features of the kernel. The shell passes the name of the command that should be executed to the exec system call. This system call reads the first two characters in a file to determine how to execute the command. In the case of shell scripts, the first two characters are #!, indicating that the script needs to be interpreted by another program instead of executed directly. The rest of the line is treated as the name of the interpreter to use.

Usually the interpreter is /bin/sh, but you can also specify options to the shell on this line. Sometimes options such as -x or -nv are specified to enable debugging. This also enables you to write scripts tuned for a particular shell such as ksh, bash, or zsh by using /bin/ksh, /bin/bash, or /bin/zsh instead of /bin/sh. (The exact path to the shell may vary from system to system.)

How can I access the name of the current shell in my initialization scripts?

In your shell initialization scripts, the name of the current shell is stored in the variable $0.

Users who have a single .profile that is shared by sh, ksh, and bash use this variable in conjunction with a case statement near the end of this file to execute additional shell–specific startups. For example, you can use the following case statement in your .profile to set up the prompt, PS1, differently depending on the shell:

case "$0" in
  *bash) PS1="\t \h \#$ " ;;
  *ksh) PS1="´uname -n´ !$ " ;;
  *sh) PS1="´uname -n´$ " ;;
esac
export PS1

Here, you have specified the shells as *bash, *ksh, and *sh, because some versions of UNIX place the - character in front of login shells, but not in front of other shells.

How do I tell whether the current shell is interactive or non-interactive?

Some scripts need the capability to determine whether they are running in an interactive shell or a non-interactive shell. Usually this is restricted to your shell initialization scripts because you don't want to perform a full-blown initialization every time these scripts execute. Some other examples include scripts that can run from the at or cron commands.

You can tell whether a shell is interactive by checking the value of the variable $-. If the value contains the letter i, the shell is interactive. Otherwise, it is non-interactive. The following case statement illustrates one method for checking the value of $-:

case $- in
  *i*) : # interactive
     # commands for interactive shells go here
    ;;
  *)  : # non interactive
     # commands for non-interactive shells go here
    ;;
esac

The following example illustrates the use of this case statement:

isInteractive () {
 case $- in
   *i* ) echo Interactive ; ec=0 ;;
   *) echo Non-Interactive ; ec=1 ;;
 esac
 return $ec
}

This function can be used to determine whether the current shell is interactive.

How do I discard the output of a command?

Sometimes you will need to execute a command, but you don't want the output displayed to the screen. In these cases you can discard the output by redirecting it to the file /dev/null:

cmd > /dev/null

Here cmd is the name of the command you want to execute. The file is a special file (called the bit bucket) that automatically discards all its input. For example, the following command discards the output of the grep command:

if grep soda /etc/hosts > /dev/null ; then
  echo 'Soda found!'
fi

Because commands also output error messages, you will often have to redirect STDERR to /dev/null. If you do not redirect STDERR, when a command fails your script will display that error message, which can be confusing to a user. To discard both output of a command and its error output, you can redirect STDERR (file descriptor 2) to STDOUT (file descriptor 1) and redirect STDOUT to /dev/null as follows:

cmd > /dev/null 2>&1

The following example illustrates redirecting both STDERR and STDOUT to /dev/null:

if grep soda /etc/hosts > /dev/null 2>&1 ; then
  echo 'Soda found!'
fi

How can I display messages on STDERR?

You can display a message on to STDERR by redirecting STDIN into STDERR as follows:

echo msg 1>&2

Here msg is the message you want to display. For example, the output of the following command is displayed on STDERR instead of STDOUT:

$ echo 'This is an error message' 1>&2

If you are interested in shell functions that perform additional formatting, please consult Chapter 21, "Problem Solving with Functions," which covers several shell functions that display messages on to STDERR.

How can I determine whether a command executed successfully?

You can determine whether a command executed successful by checking the command's exit code, which the shell stores in the variable $?. By convention, the exit code of a successful command is 0. A nonzero exit code indicates a failure.

An if statement of the following form is often used to check whether a command executed successfully:

cmd
if [ $? -eq 0 ] ; then
  : # cmd successful
else
  : # cmd failed
fi

Here cmd is a command whose exit status needs to be checked. The following example illustrates this:

grep soda /etc/hosts > /dev/null 2>&1
if [ $? -ne 0 ] ; then 
  echo "Soda Found!" 
else
  echo "No entry in /etc/hosts for soda."
fi

Here you execute a grep command and then check the exit status of that command using the value stored in $?.

How do I determine whether the shell can find a particular command?

You can check to make sure that the shell can find a command or shell function by using the type command covered in Chapter 18, "Other Tools":

type cmd > /dev/null 2>&1
if [ $? -eq 0 ] ; then 
  : # we have cmd, execute commands that require cmd
else
  : # we don't have cmd, execute alternate commands (if any)
fi

Here cmd is the name of the command you want check for. The type command is a built-in in sh, bash, and zsh. In ksh, type is usually an alias, whence -v.

An alternate form omits the explicit checking of the exit status stored in $?:

if type cmd > /dev/null 2>&1 ; then
  : # we have cmd, execute commands that require cmd
else
  : # we don't have cmd, execute alternate commands (if any)
fi

This form relies on the fact that if interprets an exit code of 0 as true.

The following example illustrate a possible use of the type command:

if type basename > /dev/null 2>&1 ; then
  : # we have basename, nothing to do
else
  # we don't have basename, define a function that
  # implements the same functionality
  basename () {
   if [ -n "$1" ] ; then
     echo "$1" | sed -e 's/^.*\///'
   else
     echo "Usage: basename [file]" 1>&2
     return 1
   fi
   return 0
  }
fi

This if statement checks to see if basename exists; if it does not, a function implementation is defined.

Can I use the && and || operators to conditionally execute commands?

The && and || operators are often used to conditionally execute commands. The basic syntax for using these operators is

cmd1 op cmd2

Here cmd1 and cmd2 are two commands and op is the && or || operator. If op is && then cmd2 is executed only when cmd1 is successful. If op is || then cmd2 is executed only when cmd1 fails.

The following example illustrates the use of &&:

type bash > /dev/null 2>&1 && 
{ HAVE_BASH=1 ; echo "bash found" ; }

This command is equivalent to the following if statement:

type bash > /dev/null 2>&1
if [ $? -eq 0 ] ; then
  HAVE_BASH=1
  echo "bash found"
fi

The following example illustrates the use of ||:

grep soda /etc/hosts > /dev/null 2>&1 || echo 'Soda not found!'

This command is equivalent to the following if statement:

grep soda /etc/hosts > /dev/null 2>&1
if [ $? -ne 0 ] ; then
  echo 'Soda not found!'
fi

How do I execute some commands in a separate shell?

The easiest way to execute a set of commands in a separate shell is to use the parentheses, (), as follows:

( list ; )

Here list is executed in a separate shell (called a sub-shell) and any changes the commands in list make to the working directory (via calls to cd) or environment variables will not affect the values in the script that invoked list.

As an example, the following function allows you to determine the absolute pathname of a directory without altering your current working directory:

abspath () { ( cd "$1" && pwd ; ) ; }

InformIT Promotional Mailings & Special Offers

I would like to receive exclusive offers and hear about products from InformIT and its family of brands. I can unsubscribe at any time.

Overview


Pearson Education, Inc., 221 River Street, Hoboken, New Jersey 07030, (Pearson) presents this site to provide information about products and services that can be purchased through this site.

This privacy notice provides an overview of our commitment to privacy and describes how we collect, protect, use and share personal information collected through this site. Please note that other Pearson websites and online products and services have their own separate privacy policies.

Collection and Use of Information


To conduct business and deliver products and services, Pearson collects and uses personal information in several ways in connection with this site, including:

Questions and Inquiries

For inquiries and questions, we collect the inquiry or question, together with name, contact details (email address, phone number and mailing address) and any other additional information voluntarily submitted to us through a Contact Us form or an email. We use this information to address the inquiry and respond to the question.

Online Store

For orders and purchases placed through our online store on this site, we collect order details, name, institution name and address (if applicable), email address, phone number, shipping and billing addresses, credit/debit card information, shipping options and any instructions. We use this information to complete transactions, fulfill orders, communicate with individuals placing orders or visiting the online store, and for related purposes.

Surveys

Pearson may offer opportunities to provide feedback or participate in surveys, including surveys evaluating Pearson products, services or sites. Participation is voluntary. Pearson collects information requested in the survey questions and uses the information to evaluate, support, maintain and improve products, services or sites, develop new products and services, conduct educational research and for other purposes specified in the survey.

Contests and Drawings

Occasionally, we may sponsor a contest or drawing. Participation is optional. Pearson collects name, contact information and other information specified on the entry form for the contest or drawing to conduct the contest or drawing. Pearson may collect additional personal information from the winners of a contest or drawing in order to award the prize and for tax reporting purposes, as required by law.

Newsletters

If you have elected to receive email newsletters or promotional mailings and special offers but want to unsubscribe, simply email information@informit.com.

Service Announcements

On rare occasions it is necessary to send out a strictly service related announcement. For instance, if our service is temporarily suspended for maintenance we might send users an email. Generally, users may not opt-out of these communications, though they can deactivate their account information. However, these communications are not promotional in nature.

Customer Service

We communicate with users on a regular basis to provide requested services and in regard to issues relating to their account we reply via email or phone in accordance with the users' wishes when a user submits their information through our Contact Us form.

Other Collection and Use of Information


Application and System Logs

Pearson automatically collects log data to help ensure the delivery, availability and security of this site. Log data may include technical information about how a user or visitor connected to this site, such as browser type, type of computer/device, operating system, internet service provider and IP address. We use this information for support purposes and to monitor the health of the site, identify problems, improve service, detect unauthorized access and fraudulent activity, prevent and respond to security incidents and appropriately scale computing resources.

Web Analytics

Pearson may use third party web trend analytical services, including Google Analytics, to collect visitor information, such as IP addresses, browser types, referring pages, pages visited and time spent on a particular site. While these analytical services collect and report information on an anonymous basis, they may use cookies to gather web trend information. The information gathered may enable Pearson (but not the third party web trend services) to link information with application and system log data. Pearson uses this information for system administration and to identify problems, improve service, detect unauthorized access and fraudulent activity, prevent and respond to security incidents, appropriately scale computing resources and otherwise support and deliver this site and its services.

Cookies and Related Technologies

This site uses cookies and similar technologies to personalize content, measure traffic patterns, control security, track use and access of information on this site, and provide interest-based messages and advertising. Users can manage and block the use of cookies through their browser. Disabling or blocking certain cookies may limit the functionality of this site.

Do Not Track

This site currently does not respond to Do Not Track signals.

Security


Pearson uses appropriate physical, administrative and technical security measures to protect personal information from unauthorized access, use and disclosure.

Children


This site is not directed to children under the age of 13.

Marketing


Pearson may send or direct marketing communications to users, provided that

  • Pearson will not use personal information collected or processed as a K-12 school service provider for the purpose of directed or targeted advertising.
  • Such marketing is consistent with applicable law and Pearson's legal obligations.
  • Pearson will not knowingly direct or send marketing communications to an individual who has expressed a preference not to receive marketing.
  • Where required by applicable law, express or implied consent to marketing exists and has not been withdrawn.

Pearson may provide personal information to a third party service provider on a restricted basis to provide marketing solely on behalf of Pearson or an affiliate or customer for whom Pearson is a service provider. Marketing preferences may be changed at any time.

Correcting/Updating Personal Information


If a user's personally identifiable information changes (such as your postal address or email address), we provide a way to correct or update that user's personal data provided to us. This can be done on the Account page. If a user no longer desires our service and desires to delete his or her account, please contact us at customer-service@informit.com and we will process the deletion of a user's account.

Choice/Opt-out


Users can always make an informed choice as to whether they should proceed with certain services offered by InformIT. If you choose to remove yourself from our mailing list(s) simply visit the following page and uncheck any communication you no longer want to receive: www.informit.com/u.aspx.

Sale of Personal Information


Pearson does not rent or sell personal information in exchange for any payment of money.

While Pearson does not sell personal information, as defined in Nevada law, Nevada residents may email a request for no sale of their personal information to NevadaDesignatedRequest@pearson.com.

Supplemental Privacy Statement for California Residents


California residents should read our Supplemental privacy statement for California residents in conjunction with this Privacy Notice. The Supplemental privacy statement for California residents explains Pearson's commitment to comply with California law and applies to personal information of California residents collected in connection with this site and the Services.

Sharing and Disclosure


Pearson may disclose personal information, as follows:

  • As required by law.
  • With the consent of the individual (or their parent, if the individual is a minor)
  • In response to a subpoena, court order or legal process, to the extent permitted or required by law
  • To protect the security and safety of individuals, data, assets and systems, consistent with applicable law
  • In connection the sale, joint venture or other transfer of some or all of its company or assets, subject to the provisions of this Privacy Notice
  • To investigate or address actual or suspected fraud or other illegal activities
  • To exercise its legal rights, including enforcement of the Terms of Use for this site or another contract
  • To affiliated Pearson companies and other companies and organizations who perform work for Pearson and are obligated to protect the privacy of personal information consistent with this Privacy Notice
  • To a school, organization, company or government agency, where Pearson collects or processes the personal information in a school setting or on behalf of such organization, company or government agency.

Links


This web site contains links to other sites. Please be aware that we are not responsible for the privacy practices of such other sites. We encourage our users to be aware when they leave our site and to read the privacy statements of each and every web site that collects Personal Information. This privacy statement applies solely to information collected by this web site.

Requests and Contact


Please contact us about this Privacy Notice or if you have any requests or questions relating to the privacy of your personal information.

Changes to this Privacy Notice


We may revise this Privacy Notice through an updated posting. We will identify the effective date of the revision in the posting. Often, updates are made to provide greater clarity or to comply with changes in regulatory requirements. If the updates involve material changes to the collection, protection, use or disclosure of Personal Information, Pearson will provide notice of the change through a conspicuous notice on this site or other appropriate way. Continued use of the site after the effective date of a posted revision evidences acceptance. Please contact us if you have questions or concerns about the Privacy Notice or any objection to any revisions.

Last Update: November 17, 2020